package com.company.sample.rest.controller;

import com.haulmont.addon.restapi.api.auth.OAuthTokenIssuer;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.security.oauth2.common.OAuth2AccessToken;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.inject.Inject;
import java.util.Collections;
import java.util.Locale;

@RestController
@RequestMapping("my-oauth")
public class MyTokenController {

    @Inject
    private OAuthTokenIssuer oAuthTokenIssuer;

    @RequestMapping(value = "/token", method = RequestMethod.GET)
    public ResponseEntity getToken() {
        OAuthTokenIssuer.OAuth2AccessTokenResult tokenResult =
                oAuthTokenIssuer.issueToken("admin", Locale.getDefault(), Collections.emptyMap());
        OAuth2AccessToken accessToken = tokenResult.getAccessToken();

        // set security HTTP headers to prevent browser caching of security token
        HttpHeaders headers = new HttpHeaders();
        headers.set(HttpHeaders.CACHE_CONTROL, "no-store");
        headers.set(HttpHeaders.PRAGMA, "no-cache");
        return new ResponseEntity<>(accessToken, headers, HttpStatus.OK);
    }

}