package com.company.sample.rest.tokenenhancer;

import com.haulmont.addon.restapi.api.auth.CubaTokenEnhancer;
import com.haulmont.cuba.core.global.AppBeans;
import com.haulmont.cuba.core.global.TimeSource;
import org.springframework.security.oauth2.common.DefaultOAuth2AccessToken;
import org.springframework.security.oauth2.common.OAuth2AccessToken;
import org.springframework.security.oauth2.provider.OAuth2Authentication;

import javax.inject.Inject;
import java.util.Date;

public class CustomTokenEnhancer extends CubaTokenEnhancer {

    @Inject
    private TimeSource timeSource;

    @Override
    public OAuth2AccessToken enhance(OAuth2AccessToken accessToken, OAuth2Authentication authentication) {
        OAuth2AccessToken token = super.enhance(accessToken, authentication);
        Object principal = authentication.getPrincipal();
        if (principal instanceof String) {
            DefaultOAuth2AccessToken mutableAccessToken = (DefaultOAuth2AccessToken) accessToken;
            int delta = getTokenExpirationMsByPrincipal((String) principal);
            mutableAccessToken.setExpiration(new Date(timeSource.currentTimeMillis() + delta));
        }
        return token;
    }

    private int getTokenExpirationMsByPrincipal(String principal) {
        if ("admin".equals(principal))
            return 60000;
        else
            return 30000;
    }
}
